# YL106 标识 类库

同时需要Clone以下仓库
- `标识类库` [IDIS.Model](http://server.bitfall.icu:3000/root/IDIS.Model.git)

新建的标识模板类继承`IDIS_Model`

就可以使用`AsTemplate`方法将其转换为模板类
### 已注册的标识模板
#### 设备
- `88.123.99@Equipment-1.0.0`
#### 物料
- `88.123.99@Material-1.0.0`
#### 订单
- `88.123.99@Oder-1.0.1`
#### 工序
- `88.123.99@Procedure_Assembly-1.0.0`
- `88.123.99@Procedure_Transport-1.0.0`
#### 产品
- `88.123.99@Product-1.0.0`
### 这些tag是什么
#### 产品
- `product` 产品
- `product_ls_black` 产品-罗氏黑签字笔
- `product_sliver_black` 产品-罗氏银签字笔
- `product_knurling` 产品-滚花签字笔
- `product_hero` 产品-英雄签字笔
#### 订单
- `order` 订单
#### 设备
- `device` 设备
#### 物料
- `material` 物料
- `material_pen_cap` 物料-笔帽
- `material_pen_core` 物料-笔芯
- `material_pen_holder` 物料-笔握
- `material_pen_body` 物料-笔身
- `material_gift_box` 物料-礼品盒总成
#### 工序
- `procedure` 工序
- `procedure_assembly` 组装工序
- `procedure_transport` 出库工序
### 如何使其成为模板类？
```csharp
IDIS_Model model = new MyModel();
var template = model.AsTemplate();
```
### 如何根据该类注册标识？
```csharp
var registerData = new IDIS_Register_Data
{
    Handle = $"88.123.99/{DateTime.Now.Ticks}",
    TemplateVersion = "Template-1.0.0",
    Value = model.AsValueInfo()
};
```
将`registerData`序列化为json,并直接Post到标识节点即可完成注册
### 如何查询包括某些标签的标识?
[httpGet]`localhost:5242/api/query/by?tags=order&today=false`

`tags`是标签,用`;`分隔

`today`是是否只查询当天的标识
### 在注册标识的时候需要注意什么?
默认类的第一个值是`Tags`,用于查找

例如`oder;product;device`就是三个标签

#### 响应结果样本
```json
{
    "message": "success",
    "status": 1,
    "data": [
        "88.123.99/202402051711"
    ]
}
```

当你在注册订单标识时,确保第一个值`Tag`中包含`order`这个标签,这样在查询订单标识时,就可以通过`order`这个标签来查找

例如:
```json
{
  "handle": "88.123.99/638504356449571895",
  "templateVersion": "Oder-1.0.0",
  "value": [
    {
      "auth": null,
      "index": 0,
      "data": {
        "format": "string",
        "value": "order"
      },
      "type": "Tags"
    },
    {
      "auth": null,
      "index": 1,
      "data": {
        "format": "String",
        "value": "20240164784"
      },
      "type": "OderNumber"
    },
    {
      "auth": null,
      "index": 2,
      "data": {
        "format": "String",
        "value": "DS-SDW"
      },
      "type": "ProductCode"
    },
    {
      "auth": null,
      "index": 3,
      "data": {
        "format": "String",
        "value": "签字笔"
      },
      "type": "ProductName"
    },
    {
      "auth": null,
      "index": 4,
      "data": {
        "format": "String",
        "value": "Oder_Created"
      },
      "type": "OrderState"
    },
    {
      "auth": null,
      "index": 5,
      "data": {
        "format": "DateTime",
        "value": "0001/1/1 0:00:00"
      },
      "type": "CreateTime"
    },
    {
      "auth": null,
      "index": 6,
      "data": {
        "format": "DateTime",
        "value": "0001/1/1 0:00:00"
      },
      "type": "UpdateTime"
    },
    {
      "auth": null,
      "index": 7,
      "data": {
        "format": "DateTime",
        "value": "0001/1/1 0:00:00"
      },
      "type": "FinishTime"
    }
  ]
}
```